#include <Wire.h>
#include <string.h>
#include "ComMotion.h"
#include "Multiservo.h"
#include "ModbusRTU.h"
#include "config.h"
#include "maindat.h"


//MS  multiservo;
Multiservo servo[SERVO_COUNT];

/*
*********************
* рабочие данные * 
*********************
*/
//контрольный регистр
int16_t		CntrlReg;
//время цикла
uint16_t 	timeCycleMax;
//массив данных для сервомашин
int16_t		dservo[SERVO_COUNT];
int16_t		wrdservo[SERVO_COUNT];
uint32_t 	cwaitservo1;			//счётчик задержки для сервомашины 1
uint32_t 	cwaitservo2;			//счётчик задержки для сервомашины 2
uint32_t 	setcwaitservo1;			//задание задержки для сервомашины 1
uint32_t 	setcwaitservo2;			//задание задержки для сервомашины 2
//массив данных для моторов
int16_t		dmotor[MOTOR_COUNT];
int16_t		wrdmotor[MOTOR_COUNT];
int16_t		cwaitmotorL;
int16_t		cwaitmotorR;
int16_t		setcwaitmotorL;
int16_t		setcwaitmotorR;
//контроль движений
MOVECTRL	movectrl;
MOVECTRL	rdmovectrl;
uint8_t		flag_movectrl;	//флаг новых данных по Modbus RTU
//время ожидания обращения
uint32_t	tSerialWait;

//номер исполнения по I2C для последовательности - цель минимизировать простой по Serial
int  dnum;

// Переменная хранящее максимальное значение uint32_t(unsigned long).
#define unsignedLongMax 4294967295UL

// Переменная хранящее 1.
#define digitalOne 1UL

uint32_t GetDifferenceULong(uint32_t BeginTime, uint32_t EndTime)
{
  	if (EndTime < BeginTime)
  	{
    		// Защита от переполнения
    		return unsignedLongMax - BeginTime + EndTime + digitalOne;
  	}
  	else
    		return EndTime - BeginTime;
	return 0;
}
uint32_t	pwait;

//
void  setup()
{
	Wire.begin ();  // Required to support I2C communication
  	sMRTU_INIT();
  	//Serial.setTimeout(_sMRTU_Timeout_4);
  	Serial.begin(_sMRTU_Baudrate);
	Serial.setTimeout(_sMRTU_Timeout_4);
  	//ComMotion
#if(_BC_Configurration > 0) //конфигурация ComMotion
  	BasicConfig(_BC_i2c_mode,
  	_BC_config,
  	_BC_lovbat,
  	_BC_M1_Imax,
  	_BC_M2_Imax,
  	_BC_M3_Imax,
  	_BC_M4_Imax,
  	_BC_i2c_nooffset,
  	1);
	delay(20);
#endif
  	//init ComMotiom shield of 4 motor drivers
  	IndividualMotorControl(_CM_M1_def, _CM_M2_def, _CM_M3_def, _CM_M4_def);
  	for(int i = 0; i<MOTOR_COUNT; ++i)
    		dmotor[i]  = 0;
  		//init Multiservo
  	for (int i = 0; i < SERVO_COUNT; ++i)
  	{
    		servo[i].attach(i);
    		servo[i].write(0);
    		//multiservo.pos[i]  = 0;
    		dservo[i]  = 0;
		wrdservo[i] = 0;
    		delay(20);
  	}
	CntrlReg	= 0;
  	dnum 		= 0;
	timeCycleMax	= 0;
	cwaitservo1	= 0;
	cwaitservo2	= 0;
	setcwaitservo1	= _cwaitservo1;
	setcwaitservo2	= _cwaitservo2;
	cwaitmotorL	= 0;
	cwaitmotorR	= 0;
	setcwaitmotorL	= 0;
	setcwaitmotorR	= 0;
	flag_movectrl	= 0;
	memset(&dmotor[0], 0, MOTOR_COUNT * 2);
	pwait		= micros();
	tSerialWait 	= 0;
}

//
void motorsANDservosNULL(void)
{
	dservo[0] 	= 0;
	setcwaitservo1	= 0;
	dservo[1] 	= 0;
	setcwaitservo2	= 0;
	dmotor[0]	= 0;
	dmotor[2]	= 0;
	setcwaitmotorL	= 0;
	dmotor[1]	= 0;
	dmotor[3]	= 0;
	setcwaitmotorR	= 0;
	flag_movectrl	= 0;
}

//
void loop()
{
	uint16_t timeCycleBegin = micros();
	//
	if(flag_movectrl)
	{
		dservo[0] 	= movectrl.servo[0];
		setcwaitservo1	= movectrl.servo_speed[0];
		dservo[1] 	= movectrl.servo[1];
		setcwaitservo2	= movectrl.servo_speed[1];
		dmotor[0]	= movectrl.motors[0];
		dmotor[2]	= movectrl.motors[0];
		setcwaitmotorL	= movectrl.speed_motors[0];
		dmotor[1]	= movectrl.motors[1];
		dmotor[3]	= movectrl.motors[1];
		setcwaitmotorR	= movectrl.speed_motors[1];
		flag_movectrl	= 0;
	}
	//
	if(GetDifferenceULong(pwait, micros()) > _i2c_wait)
	pwait = GetDifferenceULong(pwait, micros());
	{
		switch(dnum)
  		{
			//Multiservo
    			case 0:
				if(!(cwaitservo1 > 0))
				{
					servo[0].write(wrdservo[0]);
					if(wrdservo[0] < dservo[0])
						wrdservo[0]++;
					else if(wrdservo[0] > dservo[0])
						wrdservo[0]--;
					cwaitservo1	= setcwaitservo1;
				}
				else
				{
					cwaitservo1--;
					goto m0;
				}
				dnum = 1;
				break;
     			case 1:
m0:				if(!(cwaitservo2 > 0))
				{
      					servo[1].write(wrdservo[1]);
					if(wrdservo[1] < dservo[1])
						wrdservo[1]++;
					else if(wrdservo[1] > dservo[1])
						wrdservo[1]--;
      					cwaitservo2	= setcwaitservo2;
				}
				else
				{
					cwaitservo2--;
					goto m1;
				}
				dnum = 2;
      				break;
    			//ComMotion driver for 4 motors - значения моторов
    			case 2:
m1:				if(!(cwaitmotorL > 0))
				{
					if(wrdmotor[0] < dmotor[0])
						wrdmotor[0]++;
					else if(wrdmotor[0] > dmotor[0])
						wrdmotor[0]--;
					if(wrdmotor[2] < dmotor[2])
						wrdmotor[2]++;
					else if(wrdmotor[2] > dmotor[2])
						wrdmotor[2]--;
					cwaitmotorL	= setcwaitmotorL;
				}
				else
					cwaitmotorL--;
				if(!(cwaitmotorR > 0))
				{
					if(wrdmotor[1] < dmotor[1])
						wrdmotor[1]++;
					else if(wrdmotor[1] > dmotor[1])
						wrdmotor[1]--;
					if(wrdmotor[3] < dmotor[3])
						wrdmotor[3]++;
					else if(wrdmotor[3] > dmotor[3])
						wrdmotor[3]--;
					cwaitmotorR	= setcwaitmotorR;
				}
				else
					cwaitmotorR--;
				IndividualMotorControl(wrdmotor[0], wrdmotor[1], wrdmotor[2], wrdmotor[3]);
				dnum = 0;
      				break;
    			default:
      				dnum = 0;
      				break;
		}
		//формирование данных для чтения
		rdmovectrl.servo[0]		= wrdservo[0];
		rdmovectrl.servo_speed[0]	= movectrl.servo_speed[0];
		rdmovectrl.servo[1]		= wrdservo[1];
		rdmovectrl.servo_speed[1]	= movectrl.servo_speed[1];
		rdmovectrl.motors[0]		= (wrdmotor[0] + wrdmotor[2]) / 2;
		rdmovectrl.speed_motors[0]	= movectrl.speed_motors[0];
		rdmovectrl.motors[1]		= (wrdmotor[1] + wrdmotor[3]) / 2;
		rdmovectrl.speed_motors[1]	= movectrl.speed_motors[1];
  	}
	uint16_t timeCycle = (uint16_t)GetDifferenceULong((uint32_t)timeCycleBegin, (uint32_t)micros());
	if (timeCycle > timeCycleMax)
        	timeCycleMax = timeCycle;
	if((tSerialWait + timeCycle) < 0xFFFFFFFF)
		tSerialWait += timeCycle;
	if(tSerialWait > _tSerialWaitSet)
		motorsANDservosNULL();
}

//
void serialEvent()
{
	tSerialWait = 0;
 	MRTU_rWORK();
}






